/* VirtualMonitor.c generated by valac 0.40.7, the Vala compiler
 * generated from VirtualMonitor.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define DISPLAY_TYPE_VIRTUAL_MONITOR (display_virtual_monitor_get_type ())
#define DISPLAY_VIRTUAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor))
#define DISPLAY_VIRTUAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorClass))
#define DISPLAY_IS_VIRTUAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR))
#define DISPLAY_IS_VIRTUAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_VIRTUAL_MONITOR))
#define DISPLAY_VIRTUAL_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorClass))

typedef struct _DisplayVirtualMonitor DisplayVirtualMonitor;
typedef struct _DisplayVirtualMonitorClass DisplayVirtualMonitorClass;
typedef struct _DisplayVirtualMonitorPrivate DisplayVirtualMonitorPrivate;

#define TYPE_DISPLAY_TRANSFORM (display_transform_get_type ())

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;
enum  {
	DISPLAY_VIRTUAL_MONITOR_0_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_X_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_NUM_PROPERTIES
};
static GParamSpec* display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	DISPLAY_VIRTUAL_MONITOR_MODES_CHANGED_SIGNAL,
	DISPLAY_VIRTUAL_MONITOR_NUM_SIGNALS
};
static guint display_virtual_monitor_signals[DISPLAY_VIRTUAL_MONITOR_NUM_SIGNALS] = {0};

struct _DisplayVirtualMonitor {
	GObject parent_instance;
	DisplayVirtualMonitorPrivate * priv;
};

struct _DisplayVirtualMonitorClass {
	GObjectClass parent_class;
};

typedef enum  {
	DISPLAY_TRANSFORM_NORMAL = 0,
	DISPLAY_TRANSFORM_ROTATION_90 = 1,
	DISPLAY_TRANSFORM_ROTATION_180 = 2,
	DISPLAY_TRANSFORM_ROTATION_270 = 3,
	DISPLAY_TRANSFORM_FLIPPED = 4,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_90 = 5,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_180 = 6,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_270 = 7
} DisplayTransform;

struct _DisplayVirtualMonitorPrivate {
	gint _x;
	gint _y;
	gdouble _scale;
	DisplayTransform _transform;
	gboolean _primary;
	GeeLinkedList* _monitors;
};

struct _Block2Data {
	int _ref_count_;
	DisplayVirtualMonitor* self;
	DisplayMonitorMode* current_mode;
};


static gpointer display_virtual_monitor_parent_class = NULL;

GType display_virtual_monitor_get_type (void) G_GNUC_CONST;
GType display_transform_get_type (void) G_GNUC_CONST;
GType display_monitor_get_type (void) G_GNUC_CONST;
#define DISPLAY_VIRTUAL_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorPrivate))
#define DISPLAY_VIRTUAL_MONITOR_mirrored_monitor N_ ("Mirrored Display")
DisplayVirtualMonitor* display_virtual_monitor_new (void);
DisplayVirtualMonitor* display_virtual_monitor_construct (GType object_type);
const gchar* display_virtual_monitor_get_display_name (DisplayVirtualMonitor* self);
gboolean display_virtual_monitor_get_is_mirror (DisplayVirtualMonitor* self);
DisplayMonitor* display_virtual_monitor_get_monitor (DisplayVirtualMonitor* self);
const gchar* display_monitor_get_display_name (DisplayMonitor* self);
void display_virtual_monitor_get_current_mode_size (DisplayVirtualMonitor* self,
                                                    gint* width,
                                                    gint* height);
gboolean display_virtual_monitor_get_is_active (DisplayVirtualMonitor* self);
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
GeeLinkedList* display_virtual_monitor_get_monitors (DisplayVirtualMonitor* self);
DisplayMonitorMode* display_monitor_get_current_mode (DisplayMonitor* self);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
GeeLinkedList* display_virtual_monitor_get_available_modes (DisplayVirtualMonitor* self);
GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
void display_virtual_monitor_set_current_mode (DisplayVirtualMonitor* self,
                                               DisplayMonitorMode* current_mode);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ___lambda4_ (Block2Data* _data2_,
                      DisplayMonitor* _monitor);
void display_monitor_mode_set_is_current (DisplayMonitorMode* self,
                                          gboolean value);
static gboolean ____lambda4__gee_forall_func (gpointer g,
                                       gpointer self);
gint display_virtual_monitor_get_x (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_x (DisplayVirtualMonitor* self,
                                    gint value);
gint display_virtual_monitor_get_y (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_y (DisplayVirtualMonitor* self,
                                    gint value);
gdouble display_virtual_monitor_get_scale (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_scale (DisplayVirtualMonitor* self,
                                        gdouble value);
DisplayTransform display_virtual_monitor_get_transform (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_transform (DisplayVirtualMonitor* self,
                                            DisplayTransform value);
gboolean display_virtual_monitor_get_primary (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_primary (DisplayVirtualMonitor* self,
                                          gboolean value);
static void display_virtual_monitor_set_monitors (DisplayVirtualMonitor* self,
                                           GeeLinkedList* value);
gchar* display_virtual_monitor_get_id (DisplayVirtualMonitor* self);
const gchar* display_monitor_get_serial (DisplayMonitor* self);
static GObject * display_virtual_monitor_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void display_virtual_monitor_finalize (GObject * obj);
static void _vala_display_virtual_monitor_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_display_virtual_monitor_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);


DisplayVirtualMonitor*
display_virtual_monitor_construct (GType object_type)
{
	DisplayVirtualMonitor * self = NULL;
	self = (DisplayVirtualMonitor*) g_object_new (object_type, NULL);
	return self;
}


DisplayVirtualMonitor*
display_virtual_monitor_new (void)
{
	return display_virtual_monitor_construct (DISPLAY_TYPE_VIRTUAL_MONITOR);
}


const gchar*
display_virtual_monitor_get_display_name (DisplayVirtualMonitor* self)
{
	const gchar* result = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		result = _ (DISPLAY_VIRTUAL_MONITOR_mirrored_monitor);
		return result;
	} else {
		DisplayMonitor* _tmp2_;
		DisplayMonitor* _tmp3_;
		DisplayMonitor* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp2_ = display_virtual_monitor_get_monitor (self);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = display_monitor_get_display_name (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp4_);
		result = _tmp7_;
		return result;
	}
}


void
display_virtual_monitor_get_current_mode_size (DisplayVirtualMonitor* self,
                                               gint* width,
                                               gint* height)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = display_virtual_monitor_get_is_active (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		_vala_width = 1280;
		_vala_height = 720;
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = display_virtual_monitor_get_is_mirror (self);
		_tmp3_ = _tmp2_;
		if (_tmp3_) {
			DisplayMonitorMode* current_mode = NULL;
			GeeLinkedList* _tmp4_;
			gpointer _tmp5_;
			DisplayMonitor* _tmp6_;
			DisplayMonitorMode* _tmp7_;
			DisplayMonitorMode* _tmp8_;
			DisplayMonitorMode* _tmp9_;
			DisplayMonitorMode* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			DisplayMonitorMode* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			_tmp4_ = self->priv->_monitors;
			_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, 0);
			_tmp6_ = (DisplayMonitor*) _tmp5_;
			_tmp7_ = display_monitor_get_current_mode (_tmp6_);
			_tmp8_ = _tmp7_;
			_tmp9_ = _tmp8_;
			_g_object_unref0 (_tmp6_);
			current_mode = _tmp9_;
			_tmp10_ = current_mode;
			_tmp11_ = display_monitor_mode_get_width (_tmp10_);
			_tmp12_ = _tmp11_;
			_vala_width = _tmp12_;
			_tmp13_ = current_mode;
			_tmp14_ = display_monitor_mode_get_height (_tmp13_);
			_tmp15_ = _tmp14_;
			_vala_height = _tmp15_;
			_g_object_unref0 (current_mode);
		} else {
			DisplayMonitorMode* current_mode = NULL;
			DisplayMonitor* _tmp16_;
			DisplayMonitor* _tmp17_;
			DisplayMonitor* _tmp18_;
			DisplayMonitorMode* _tmp19_;
			DisplayMonitorMode* _tmp20_;
			DisplayMonitorMode* _tmp21_;
			DisplayMonitorMode* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			DisplayMonitorMode* _tmp25_;
			gint _tmp26_;
			gint _tmp27_;
			_tmp16_ = display_virtual_monitor_get_monitor (self);
			_tmp17_ = _tmp16_;
			_tmp18_ = _tmp17_;
			_tmp19_ = display_monitor_get_current_mode (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = _tmp20_;
			_g_object_unref0 (_tmp18_);
			current_mode = _tmp21_;
			_tmp22_ = current_mode;
			_tmp23_ = display_monitor_mode_get_width (_tmp22_);
			_tmp24_ = _tmp23_;
			_vala_width = _tmp24_;
			_tmp25_ = current_mode;
			_tmp26_ = display_monitor_mode_get_height (_tmp25_);
			_tmp27_ = _tmp26_;
			_vala_height = _tmp27_;
			_g_object_unref0 (current_mode);
		}
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


GeeLinkedList*
display_virtual_monitor_get_available_modes (DisplayVirtualMonitor* self)
{
	GeeLinkedList* result = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GeeLinkedList* _tmp2_;
		GeeLinkedList* _tmp3_;
		_tmp2_ = self->priv->_monitors;
		_tmp3_ = display_utils_get_common_monitor_modes (_tmp2_);
		result = _tmp3_;
		return result;
	} else {
		DisplayMonitor* _tmp4_;
		DisplayMonitor* _tmp5_;
		DisplayMonitor* _tmp6_;
		GeeLinkedList* _tmp7_;
		GeeLinkedList* _tmp8_;
		GeeLinkedList* _tmp9_;
		GeeLinkedList* _tmp10_;
		_tmp4_ = display_virtual_monitor_get_monitor (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = display_monitor_get_modes (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = _g_object_ref0 (_tmp8_);
		_tmp10_ = _tmp9_;
		_g_object_unref0 (_tmp6_);
		result = _tmp10_;
		return result;
	}
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		DisplayVirtualMonitor* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->current_mode);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static gboolean
___lambda4_ (Block2Data* _data2_,
             DisplayMonitor* _monitor)
{
	DisplayVirtualMonitor* self;
	gboolean result = FALSE;
	gboolean mode_found = FALSE;
	self = _data2_->self;
	g_return_val_if_fail (_monitor != NULL, FALSE);
	mode_found = FALSE;
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _mode_index = 0;
		_tmp0_ = display_monitor_get_modes (_monitor);
		_tmp1_ = _tmp0_;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_mode_list = _tmp2_;
		_tmp3_ = _mode_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_mode_size = _tmp5_;
		_mode_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp14_ = FALSE;
			DisplayMonitorMode* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			_tmp6_ = _mode_index;
			_mode_index = _tmp6_ + 1;
			_tmp7_ = _mode_index;
			_tmp8_ = _mode_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _mode_list;
			_tmp10_ = _mode_index;
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
			mode = (DisplayMonitorMode*) _tmp11_;
			_tmp12_ = mode_found;
			if (_tmp12_) {
				DisplayMonitorMode* _tmp13_;
				_tmp13_ = mode;
				display_monitor_mode_set_is_current (_tmp13_, FALSE);
				_g_object_unref0 (mode);
				continue;
			}
			_tmp15_ = mode;
			_tmp16_ = display_monitor_mode_get_width (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = display_monitor_mode_get_width (_data2_->current_mode);
			_tmp19_ = _tmp18_;
			if (_tmp17_ == _tmp19_) {
				DisplayMonitorMode* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				_tmp20_ = mode;
				_tmp21_ = display_monitor_mode_get_height (_tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = display_monitor_mode_get_height (_data2_->current_mode);
				_tmp24_ = _tmp23_;
				_tmp14_ = _tmp22_ == _tmp24_;
			} else {
				_tmp14_ = FALSE;
			}
			if (_tmp14_) {
				DisplayMonitorMode* _tmp25_;
				mode_found = TRUE;
				_tmp25_ = mode;
				display_monitor_mode_set_is_current (_tmp25_, TRUE);
			} else {
				DisplayMonitorMode* _tmp26_;
				_tmp26_ = mode;
				display_monitor_mode_set_is_current (_tmp26_, FALSE);
			}
			_g_object_unref0 (mode);
		}
		_g_object_unref0 (_mode_list);
	}
	result = TRUE;
	_g_object_unref0 (_monitor);
	return result;
}


static gboolean
____lambda4__gee_forall_func (gpointer g,
                              gpointer self)
{
	gboolean result;
	result = ___lambda4_ (self, (DisplayMonitor*) g);
	return result;
}


void
display_virtual_monitor_set_current_mode (DisplayVirtualMonitor* self,
                                          DisplayMonitorMode* current_mode)
{
	Block2Data* _data2_;
	DisplayMonitorMode* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (current_mode != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (current_mode);
	_g_object_unref0 (_data2_->current_mode);
	_data2_->current_mode = _tmp0_;
	_tmp1_ = display_virtual_monitor_get_is_mirror (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GeeLinkedList* _tmp3_;
		_tmp3_ = self->priv->_monitors;
		gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp3_, ____lambda4__gee_forall_func, _data2_);
	} else {
		{
			GeeLinkedList* _mode_list = NULL;
			DisplayMonitor* _tmp4_;
			DisplayMonitor* _tmp5_;
			DisplayMonitor* _tmp6_;
			GeeLinkedList* _tmp7_;
			GeeLinkedList* _tmp8_;
			GeeLinkedList* _tmp9_;
			GeeLinkedList* _tmp10_;
			gint _mode_size = 0;
			GeeLinkedList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _mode_index = 0;
			_tmp4_ = display_virtual_monitor_get_monitor (self);
			_tmp5_ = _tmp4_;
			_tmp6_ = _tmp5_;
			_tmp7_ = display_monitor_get_modes (_tmp6_);
			_tmp8_ = _tmp7_;
			_tmp9_ = _g_object_ref0 (_tmp8_);
			_tmp10_ = _tmp9_;
			_g_object_unref0 (_tmp6_);
			_mode_list = _tmp10_;
			_tmp11_ = _mode_list;
			_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
			_tmp13_ = _tmp12_;
			_mode_size = _tmp13_;
			_mode_index = -1;
			while (TRUE) {
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				DisplayMonitorMode* mode = NULL;
				GeeLinkedList* _tmp17_;
				gint _tmp18_;
				gpointer _tmp19_;
				DisplayMonitorMode* _tmp20_;
				DisplayMonitorMode* _tmp21_;
				_tmp14_ = _mode_index;
				_mode_index = _tmp14_ + 1;
				_tmp15_ = _mode_index;
				_tmp16_ = _mode_size;
				if (!(_tmp15_ < _tmp16_)) {
					break;
				}
				_tmp17_ = _mode_list;
				_tmp18_ = _mode_index;
				_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _tmp18_);
				mode = (DisplayMonitorMode*) _tmp19_;
				_tmp20_ = mode;
				_tmp21_ = mode;
				display_monitor_mode_set_is_current (_tmp20_, _tmp21_ == _data2_->current_mode);
				_g_object_unref0 (mode);
			}
			_g_object_unref0 (_mode_list);
		}
	}
	block2_data_unref (_data2_);
	_data2_ = NULL;
}


gint
display_virtual_monitor_get_x (DisplayVirtualMonitor* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_x;
	result = _tmp0_;
	return result;
}


void
display_virtual_monitor_set_x (DisplayVirtualMonitor* self,
                               gint value)
{
	g_return_if_fail (self != NULL);
	if (display_virtual_monitor_get_x (self) != value) {
		self->priv->_x = value;
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_X_PROPERTY]);
	}
}


gint
display_virtual_monitor_get_y (DisplayVirtualMonitor* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_y;
	result = _tmp0_;
	return result;
}


void
display_virtual_monitor_set_y (DisplayVirtualMonitor* self,
                               gint value)
{
	g_return_if_fail (self != NULL);
	if (display_virtual_monitor_get_y (self) != value) {
		self->priv->_y = value;
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY]);
	}
}


gdouble
display_virtual_monitor_get_scale (DisplayVirtualMonitor* self)
{
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_scale;
	result = _tmp0_;
	return result;
}


void
display_virtual_monitor_set_scale (DisplayVirtualMonitor* self,
                                   gdouble value)
{
	g_return_if_fail (self != NULL);
	if (display_virtual_monitor_get_scale (self) != value) {
		self->priv->_scale = value;
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY]);
	}
}


DisplayTransform
display_virtual_monitor_get_transform (DisplayVirtualMonitor* self)
{
	DisplayTransform result;
	DisplayTransform _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_transform;
	result = _tmp0_;
	return result;
}


void
display_virtual_monitor_set_transform (DisplayVirtualMonitor* self,
                                       DisplayTransform value)
{
	g_return_if_fail (self != NULL);
	if (display_virtual_monitor_get_transform (self) != value) {
		self->priv->_transform = value;
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY]);
	}
}


gboolean
display_virtual_monitor_get_primary (DisplayVirtualMonitor* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_primary;
	result = _tmp0_;
	return result;
}


void
display_virtual_monitor_set_primary (DisplayVirtualMonitor* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	if (display_virtual_monitor_get_primary (self) != value) {
		self->priv->_primary = value;
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY]);
	}
}


GeeLinkedList*
display_virtual_monitor_get_monitors (DisplayVirtualMonitor* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_monitors;
	result = _tmp0_;
	return result;
}


static void
display_virtual_monitor_set_monitors (DisplayVirtualMonitor* self,
                                      GeeLinkedList* value)
{
	g_return_if_fail (self != NULL);
	if (display_virtual_monitor_get_monitors (self) != value) {
		GeeLinkedList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_monitors);
		self->priv->_monitors = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY]);
	}
}


gchar*
display_virtual_monitor_get_id (DisplayVirtualMonitor* self)
{
	gchar* result;
	gchar* val = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	val = _tmp0_;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _monitor_index = 0;
		_tmp1_ = self->priv->_monitors;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_monitor_list = _tmp2_;
		_tmp3_ = _monitor_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_monitor_size = _tmp5_;
		_monitor_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			const gchar* _tmp12_;
			DisplayMonitor* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			_tmp6_ = _monitor_index;
			_monitor_index = _tmp6_ + 1;
			_tmp7_ = _monitor_index;
			_tmp8_ = _monitor_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _monitor_list;
			_tmp10_ = _monitor_index;
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
			monitor = (DisplayMonitor*) _tmp11_;
			_tmp12_ = val;
			_tmp13_ = monitor;
			_tmp14_ = display_monitor_get_serial (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
			_g_free0 (val);
			val = _tmp16_;
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = val;
	return result;
}


gboolean
display_virtual_monitor_get_is_mirror (DisplayVirtualMonitor* self)
{
	gboolean result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_monitors;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_ > 1;
	return result;
}


gboolean
display_virtual_monitor_get_is_active (DisplayVirtualMonitor* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = TRUE;
	return result;
}


DisplayMonitor*
display_virtual_monitor_get_monitor (DisplayVirtualMonitor* self)
{
	DisplayMonitor* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeLinkedList* _tmp2_;
	gpointer _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		g_critical ("VirtualMonitor.vala:66: Do not use Display.VirtualMonitor.monitor in a" \
" mirror context!");
	}
	_tmp2_ = self->priv->_monitors;
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, 0);
	result = (DisplayMonitor*) _tmp3_;
	return result;
}


static GObject *
display_virtual_monitor_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayVirtualMonitor * self;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	parent_class = G_OBJECT_CLASS (display_virtual_monitor_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	display_virtual_monitor_set_monitors (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	return obj;
}


static void
display_virtual_monitor_class_init (DisplayVirtualMonitorClass * klass)
{
	display_virtual_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DisplayVirtualMonitorPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_display_virtual_monitor_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_display_virtual_monitor_set_property;
	G_OBJECT_CLASS (klass)->constructor = display_virtual_monitor_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_virtual_monitor_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_X_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_X_PROPERTY] = g_param_spec_int ("x", "x", "x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY] = g_param_spec_int ("y", "y", "y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY] = g_param_spec_double ("scale", "scale", "scale", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY] = g_param_spec_enum ("transform", "transform", "transform", TYPE_DISPLAY_TRANSFORM, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY] = g_param_spec_boolean ("primary", "primary", "primary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY] = g_param_spec_object ("monitors", "monitors", "monitors", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY] = g_param_spec_boolean ("is-mirror", "is-mirror", "is-mirror", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY] = g_param_spec_boolean ("is-active", "is-active", "is-active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY] = g_param_spec_object ("monitor", "monitor", "monitor", DISPLAY_TYPE_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	display_virtual_monitor_signals[DISPLAY_VIRTUAL_MONITOR_MODES_CHANGED_SIGNAL] = g_signal_new ("modes-changed", DISPLAY_TYPE_VIRTUAL_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
display_virtual_monitor_instance_init (DisplayVirtualMonitor * self)
{
	self->priv = DISPLAY_VIRTUAL_MONITOR_GET_PRIVATE (self);
}


static void
display_virtual_monitor_finalize (GObject * obj)
{
	DisplayVirtualMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
	_g_object_unref0 (self->priv->_monitors);
	G_OBJECT_CLASS (display_virtual_monitor_parent_class)->finalize (obj);
}


GType
display_virtual_monitor_get_type (void)
{
	static volatile gsize display_virtual_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&display_virtual_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DisplayVirtualMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_virtual_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayVirtualMonitor), 0, (GInstanceInitFunc) display_virtual_monitor_instance_init, NULL };
		GType display_virtual_monitor_type_id;
		display_virtual_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DisplayVirtualMonitor", &g_define_type_info, 0);
		g_once_init_leave (&display_virtual_monitor_type_id__volatile, display_virtual_monitor_type_id);
	}
	return display_virtual_monitor_type_id__volatile;
}


static void
_vala_display_virtual_monitor_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	DisplayVirtualMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
	switch (property_id) {
		case DISPLAY_VIRTUAL_MONITOR_X_PROPERTY:
		g_value_set_int (value, display_virtual_monitor_get_x (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY:
		g_value_set_int (value, display_virtual_monitor_get_y (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY:
		g_value_set_double (value, display_virtual_monitor_get_scale (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY:
		g_value_set_enum (value, display_virtual_monitor_get_transform (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY:
		g_value_set_boolean (value, display_virtual_monitor_get_primary (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY:
		g_value_set_object (value, display_virtual_monitor_get_monitors (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY:
		g_value_take_string (value, display_virtual_monitor_get_id (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY:
		g_value_set_boolean (value, display_virtual_monitor_get_is_mirror (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY:
		g_value_set_boolean (value, display_virtual_monitor_get_is_active (self));
		break;
		case DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY:
		g_value_take_object (value, display_virtual_monitor_get_monitor (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_display_virtual_monitor_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	DisplayVirtualMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
	switch (property_id) {
		case DISPLAY_VIRTUAL_MONITOR_X_PROPERTY:
		display_virtual_monitor_set_x (self, g_value_get_int (value));
		break;
		case DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY:
		display_virtual_monitor_set_y (self, g_value_get_int (value));
		break;
		case DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY:
		display_virtual_monitor_set_scale (self, g_value_get_double (value));
		break;
		case DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY:
		display_virtual_monitor_set_transform (self, g_value_get_enum (value));
		break;
		case DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY:
		display_virtual_monitor_set_primary (self, g_value_get_boolean (value));
		break;
		case DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY:
		display_virtual_monitor_set_monitors (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



