/* Utils.c generated by valac 0.40.7, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;



gboolean display_utils_has_touchscreen (void);
GType display_monitor_get_type (void) G_GNUC_CONST;
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors);
gdouble display_utils_get_min_compatible_scale (GeeLinkedList* monitors);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
gdouble* display_monitor_mode_get_supported_scales (DisplayMonitorMode* self,
                                                    int* result_length1);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      int stack_length,
                                      gdouble needle);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
gdouble display_monitor_get_max_scale (DisplayMonitor* self);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


gboolean
display_utils_has_touchscreen (void)
{
	gboolean result = FALSE;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	_tmp0_ = gdk_display_get_default ();
	display = _tmp0_;
	_tmp1_ = display;
	if (_tmp1_ != NULL) {
		GdkDeviceManager* manager = NULL;
		GdkDisplay* _tmp2_;
		GdkDeviceManager* _tmp3_;
		GdkDeviceManager* _tmp4_;
		GList* devices = NULL;
		GdkDeviceManager* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
		_tmp2_ = display;
		_tmp3_ = gdk_display_get_device_manager (_tmp2_);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		manager = _tmp4_;
		_tmp5_ = manager;
		_tmp6_ = gdk_device_manager_list_devices (_tmp5_, GDK_DEVICE_TYPE_SLAVE);
		devices = _tmp6_;
		_tmp7_ = devices;
		{
			GList* device_collection = NULL;
			GList* device_it = NULL;
			device_collection = _tmp7_;
			for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
				GdkDevice* device = NULL;
				device = (GdkDevice*) device_it->data;
				{
					GdkDevice* _tmp8_;
					GdkInputSource _tmp9_;
					GdkInputSource _tmp10_;
					_tmp8_ = device;
					g_object_get (_tmp8_, "input-source", &_tmp9_, NULL);
					_tmp10_ = _tmp9_;
					if (_tmp10_ == GDK_SOURCE_TOUCHSCREEN) {
						result = TRUE;
						(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
						_g_object_unref0 (manager);
						return result;
					}
				}
			}
		}
		(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
		_g_object_unref0 (manager);
	}
	result = FALSE;
	return result;
}


static gboolean
_vala_double_array_contains (gdouble * stack,
                             int stack_length,
                             gdouble needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}


GeeLinkedList*
display_utils_get_common_monitor_modes (GeeLinkedList* monitors)
{
	GeeLinkedList* result = NULL;
	GeeLinkedList* common_modes = NULL;
	GeeLinkedList* _tmp0_;
	gdouble min_scale = 0.0;
	gboolean first_monitor = FALSE;
	g_return_val_if_fail (monitors != NULL, NULL);
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	common_modes = _tmp0_;
	min_scale = display_utils_get_min_compatible_scale (monitors);
	first_monitor = TRUE;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
		_tmp1_ = _g_object_ref0 (monitors);
		_monitor_list = _tmp1_;
		_tmp2_ = _monitor_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_monitor_size = _tmp4_;
		_monitor_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gboolean _tmp11_;
			_tmp5_ = _monitor_index;
			_monitor_index = _tmp5_ + 1;
			_tmp6_ = _monitor_index;
			_tmp7_ = _monitor_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _monitor_list;
			_tmp9_ = _monitor_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			monitor = (DisplayMonitor*) _tmp10_;
			_tmp11_ = first_monitor;
			if (_tmp11_) {
				{
					GeeLinkedList* _mode_list = NULL;
					DisplayMonitor* _tmp12_;
					GeeLinkedList* _tmp13_;
					GeeLinkedList* _tmp14_;
					GeeLinkedList* _tmp15_;
					gint _mode_size = 0;
					GeeLinkedList* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gint _mode_index = 0;
					_tmp12_ = monitor;
					_tmp13_ = display_monitor_get_modes (_tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = _g_object_ref0 (_tmp14_);
					_mode_list = _tmp15_;
					_tmp16_ = _mode_list;
					_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
					_tmp18_ = _tmp17_;
					_mode_size = _tmp18_;
					_mode_index = -1;
					while (TRUE) {
						gint _tmp19_;
						gint _tmp20_;
						gint _tmp21_;
						DisplayMonitorMode* mode = NULL;
						GeeLinkedList* _tmp22_;
						gint _tmp23_;
						gpointer _tmp24_;
						gdouble _tmp25_;
						DisplayMonitorMode* _tmp26_;
						gdouble* _tmp27_;
						gint _tmp27__length1;
						gdouble* _tmp28_;
						gint _tmp28__length1;
						_tmp19_ = _mode_index;
						_mode_index = _tmp19_ + 1;
						_tmp20_ = _mode_index;
						_tmp21_ = _mode_size;
						if (!(_tmp20_ < _tmp21_)) {
							break;
						}
						_tmp22_ = _mode_list;
						_tmp23_ = _mode_index;
						_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, _tmp23_);
						mode = (DisplayMonitorMode*) _tmp24_;
						_tmp25_ = min_scale;
						_tmp26_ = mode;
						_tmp27_ = display_monitor_mode_get_supported_scales (_tmp26_, &_tmp27__length1);
						_tmp28_ = _tmp27_;
						_tmp28__length1 = _tmp27__length1;
						if (_vala_double_array_contains (_tmp28_, _tmp28__length1, _tmp25_)) {
							GeeLinkedList* _tmp29_;
							DisplayMonitorMode* _tmp30_;
							_tmp29_ = common_modes;
							_tmp30_ = mode;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp30_);
						}
						_g_object_unref0 (mode);
					}
					_g_object_unref0 (_mode_list);
				}
				first_monitor = FALSE;
			} else {
				GeeLinkedList* to_remove = NULL;
				GeeLinkedList* _tmp31_;
				GeeLinkedList* _tmp72_;
				GeeLinkedList* _tmp73_;
				_tmp31_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
				to_remove = _tmp31_;
				{
					GeeLinkedList* _mode_to_check_list = NULL;
					GeeLinkedList* _tmp32_;
					GeeLinkedList* _tmp33_;
					gint _mode_to_check_size = 0;
					GeeLinkedList* _tmp34_;
					gint _tmp35_;
					gint _tmp36_;
					gint _mode_to_check_index = 0;
					_tmp32_ = common_modes;
					_tmp33_ = _g_object_ref0 (_tmp32_);
					_mode_to_check_list = _tmp33_;
					_tmp34_ = _mode_to_check_list;
					_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
					_tmp36_ = _tmp35_;
					_mode_to_check_size = _tmp36_;
					_mode_to_check_index = -1;
					while (TRUE) {
						gint _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
						DisplayMonitorMode* mode_to_check = NULL;
						GeeLinkedList* _tmp40_;
						gint _tmp41_;
						gpointer _tmp42_;
						gboolean mode_found = FALSE;
						gboolean _tmp69_;
						_tmp37_ = _mode_to_check_index;
						_mode_to_check_index = _tmp37_ + 1;
						_tmp38_ = _mode_to_check_index;
						_tmp39_ = _mode_to_check_size;
						if (!(_tmp38_ < _tmp39_)) {
							break;
						}
						_tmp40_ = _mode_to_check_list;
						_tmp41_ = _mode_to_check_index;
						_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, _tmp41_);
						mode_to_check = (DisplayMonitorMode*) _tmp42_;
						mode_found = FALSE;
						{
							GeeLinkedList* _monitor_mode_list = NULL;
							DisplayMonitor* _tmp43_;
							GeeLinkedList* _tmp44_;
							GeeLinkedList* _tmp45_;
							GeeLinkedList* _tmp46_;
							gint _monitor_mode_size = 0;
							GeeLinkedList* _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							gint _monitor_mode_index = 0;
							_tmp43_ = monitor;
							_tmp44_ = display_monitor_get_modes (_tmp43_);
							_tmp45_ = _tmp44_;
							_tmp46_ = _g_object_ref0 (_tmp45_);
							_monitor_mode_list = _tmp46_;
							_tmp47_ = _monitor_mode_list;
							_tmp48_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp47_);
							_tmp49_ = _tmp48_;
							_monitor_mode_size = _tmp49_;
							_monitor_mode_index = -1;
							while (TRUE) {
								gint _tmp50_;
								gint _tmp51_;
								gint _tmp52_;
								DisplayMonitorMode* monitor_mode = NULL;
								GeeLinkedList* _tmp53_;
								gint _tmp54_;
								gpointer _tmp55_;
								gboolean _tmp56_ = FALSE;
								DisplayMonitorMode* _tmp57_;
								gint _tmp58_;
								gint _tmp59_;
								DisplayMonitorMode* _tmp60_;
								gint _tmp61_;
								gint _tmp62_;
								_tmp50_ = _monitor_mode_index;
								_monitor_mode_index = _tmp50_ + 1;
								_tmp51_ = _monitor_mode_index;
								_tmp52_ = _monitor_mode_size;
								if (!(_tmp51_ < _tmp52_)) {
									break;
								}
								_tmp53_ = _monitor_mode_list;
								_tmp54_ = _monitor_mode_index;
								_tmp55_ = gee_abstract_list_get ((GeeAbstractList*) _tmp53_, _tmp54_);
								monitor_mode = (DisplayMonitorMode*) _tmp55_;
								_tmp57_ = mode_to_check;
								_tmp58_ = display_monitor_mode_get_width (_tmp57_);
								_tmp59_ = _tmp58_;
								_tmp60_ = monitor_mode;
								_tmp61_ = display_monitor_mode_get_width (_tmp60_);
								_tmp62_ = _tmp61_;
								if (_tmp59_ == _tmp62_) {
									DisplayMonitorMode* _tmp63_;
									gint _tmp64_;
									gint _tmp65_;
									DisplayMonitorMode* _tmp66_;
									gint _tmp67_;
									gint _tmp68_;
									_tmp63_ = mode_to_check;
									_tmp64_ = display_monitor_mode_get_height (_tmp63_);
									_tmp65_ = _tmp64_;
									_tmp66_ = monitor_mode;
									_tmp67_ = display_monitor_mode_get_height (_tmp66_);
									_tmp68_ = _tmp67_;
									_tmp56_ = _tmp65_ == _tmp68_;
								} else {
									_tmp56_ = FALSE;
								}
								if (_tmp56_) {
									mode_found = TRUE;
									_g_object_unref0 (monitor_mode);
									break;
								}
								_g_object_unref0 (monitor_mode);
							}
							_g_object_unref0 (_monitor_mode_list);
						}
						_tmp69_ = mode_found;
						if (_tmp69_ == FALSE) {
							GeeLinkedList* _tmp70_;
							DisplayMonitorMode* _tmp71_;
							_tmp70_ = to_remove;
							_tmp71_ = mode_to_check;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp70_, _tmp71_);
						}
						_g_object_unref0 (mode_to_check);
					}
					_g_object_unref0 (_mode_to_check_list);
				}
				_tmp72_ = common_modes;
				_tmp73_ = to_remove;
				gee_collection_remove_all ((GeeCollection*) _tmp72_, (GeeCollection*) _tmp73_);
				_g_object_unref0 (to_remove);
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = common_modes;
	return result;
}


gdouble
display_utils_get_min_compatible_scale (GeeLinkedList* monitors)
{
	gdouble result = 0.0;
	gdouble min_scale = 0.0;
	g_return_val_if_fail (monitors != NULL, 0.0);
	min_scale = DBL_MAX;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
		_tmp0_ = _g_object_ref0 (monitors);
		_monitor_list = _tmp0_;
		_tmp1_ = _monitor_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_monitor_size = _tmp3_;
		_monitor_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_;
			gdouble _tmp10_;
			DisplayMonitor* _tmp11_;
			_tmp4_ = _monitor_index;
			_monitor_index = _tmp4_ + 1;
			_tmp5_ = _monitor_index;
			_tmp6_ = _monitor_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _monitor_list;
			_tmp8_ = _monitor_index;
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
			monitor = (DisplayMonitor*) _tmp9_;
			_tmp10_ = min_scale;
			_tmp11_ = monitor;
			min_scale = MIN (_tmp10_, display_monitor_get_max_scale (_tmp11_));
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = min_scale;
	return result;
}



